#include "StdAfx.h"
#include "global.h"
#include "s_comm.h"
#include "helo_class.h"

UINT HelloFunctionThread(LPVOID pParam)
{
	Helo_class * mhelo = (Helo_class *) pParam;
	int a,c,e,f;
	unsigned char b,d,send_buffer[6],tmp_lo,tmp_hi;
	CString m_error;
	CSingleLock hlock(&hello_mutex);
	CSingleLock slock(&scomm_mutex);
	CSingleLock ulock(&ui_mutex);


	while(1)
	{
		ulock.Lock();
		f=mhelo->my_ptrback->terminate;
		ulock.Unlock();
		if(f)
			AfxEndThread(0);
		d=true;
		hlock.Lock();
		b=mhelo->Get_Status();
		a=c=mhelo->Get_Intervall();
		hlock.Unlock();
		if(b)
		{
			m_error="";
			send_buffer[0]=START_FRAME;
			Convert2Code(COMMAND_HELLO,tmp_lo,tmp_hi);
			send_buffer[1]= tmp_lo;
			send_buffer[2]= tmp_hi;
			send_buffer[3] = END_FRAME;
			hlock.Lock();
			slock.Lock();			
			mhelo->my_scomm->Write(send_buffer,4,m_error);
			slock.Unlock();
			hlock.Unlock();
			ulock.Lock();
			mhelo->my_ptrback->AddLogM(m_error);
			ulock.Unlock();
		}
		while((a>1000)&&d)
		{
			Sleep(1000);
			a-=1000;
			hlock.Lock();
			e=mhelo->Get_Intervall();
			hlock.Unlock();
			if(e!=c)
				d=false;
		}
		if(d)
			Sleep(a);
	}
}

Helo_class::Helo_class(void)
{
}

Helo_class::~Helo_class(void)
{
}

void Helo_class::SetUp(char en, int iv, S_comm * scom, CNRL66ClientDlg *mpt)
{
	enabled=en;
	intervall=iv;
	my_scomm=scom;
	my_ptrback  = mpt;
}
