#pragma once
#include <afxmt.h>
#include "global.h"
#include "s_comm.h"
#include "NRL66Client.h"
#include "NRL66ClientDlg.h"

UINT HelloFunctionThread(LPVOID pParam);

class Helo_class
{
public:
	Helo_class(void);
	~Helo_class(void);
	void SetUp(char en, int iv, S_comm * scom, CNRL66ClientDlg *mpt);
	inline void Set_Intervall(int ival) {intervall=ival;};
	inline void Start() {enabled = TRUE;};
	inline void Stop() {enabled = FALSE;};
	inline unsigned char Get_Status() {return enabled;};
	inline int Get_Intervall() {return intervall;};

	S_comm * my_scomm;
	CNRL66ClientDlg * my_ptrback;
private:
	unsigned char enabled;
	int intervall;
};
