// NRL66ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "global.h"
#include "s_comm.h"
#include "NRL66Client.h"
#include "NRL66ClientDlg.h"
#include "inbuffer.h"
#include "Helo_class.h"
#include ".\nrl66clientdlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MY_TIMER_REFRESH 1
#define MY_TIMER_FOLLOW 2

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CNRL66ClientDlg dialog



CNRL66ClientDlg::CNRL66ClientDlg(CWnd* pParent /*=NULL*/)
: CDialog(CNRL66ClientDlg::IDD, pParent)
, box_comport(_T("9"))
, box_messages(_T(""))
, clearscreen(FALSE)
, terminate(FALSE)
, commresp(_T(""))
, comment_box(_T(""))
, cmd_cmd_char(_T(""))
, cmd_cmd_param1(_T(""))
, cmd_cmd_param2(_T(""))
, cmd_cmd_param3(_T(""))
, cmd_cmd_paramlength(_T(""))
, Box_S_Value_1(_T(""))
, Box_A_Value_1(_T(""))
, Box_1_Value_1(_T(""))
, Box_9_Value_1(_T(""))
, Box_N_Value_1(_T(""))
, Box_N_Value_2(_T(""))
, Box_R_Value_1(_T(""))
, Box_R_Value_2(_T(""))
, Box_9_Value_2(_T(""))
, Box_P_Value_2(_T(""))
, Box_P_Value_1(_T(""))

{
	for(int k=0;k<16;k++)
	{
		disp_adc[k]="32768";
		AVG_BOX[k]="0";
	}
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNRL66ClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_COMPORT, box_comport);
	DDX_Text(pDX, IDC_MESSAGES, box_messages);
	DDX_Text(pDX, IDC_COMMRESP, commresp);
	DDX_Text(pDX, IDC_EDIT0, disp_adc[0]);
	DDX_Text(pDX, IDC_EDIT1, disp_adc[1]);
	DDX_Text(pDX, IDC_EDIT2, disp_adc[2]);
	DDX_Text(pDX, IDC_EDIT3, disp_adc[3]);
	DDX_Text(pDX, IDC_EDIT4, disp_adc[4]);
	DDX_Text(pDX, IDC_EDIT5, disp_adc[5]);
	DDX_Text(pDX, IDC_EDIT6, disp_adc[6]);
	DDX_Text(pDX, IDC_EDIT7, disp_adc[7]);
	DDX_Text(pDX, IDC_EDIT8, disp_adc[8]);
	DDX_Text(pDX, IDC_EDIT9, disp_adc[9]);
	DDX_Text(pDX, IDC_EDITA, disp_adc[10]);
	DDX_Text(pDX, IDC_EDITB, disp_adc[11]);
	DDX_Text(pDX, IDC_EDITC, disp_adc[12]);
	DDX_Text(pDX, IDC_EDITD, disp_adc[13]);
	DDX_Text(pDX, IDC_EDITE, disp_adc[14]);
	DDX_Text(pDX, IDC_EDITF, disp_adc[15]);
	DDX_Text(pDX, IDC_COMMENTS, comment_box);
	DDX_Text(pDX, IDC_CMD_INPT1, cmd_cmd_char);
	DDX_Text(pDX, IDC_CMD_INPT2, cmd_cmd_param1);
	DDX_Text(pDX, IDC_CMD_INPT3, cmd_cmd_param2);
	DDX_Text(pDX, IDC_CMD_INPT4, cmd_cmd_param3);
	DDX_Text(pDX, IDC_CMD_INPT5, cmd_cmd_paramlength);
	DDX_Text(pDX, IDC_CMD_INPT6, Box_S_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT7, Box_A_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT8, Box_1_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT9, Box_9_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT10, Box_N_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT11, Box_N_Value_2);
	DDX_Text(pDX, IDC_CMD_INPT12, Box_R_Value_1);
	DDX_Text(pDX, IDC_CMD_INPT13, Box_R_Value_2);
	DDX_Text(pDX, IDC_CMD_INPT15, Box_P_Value_2);
	DDX_Text(pDX, IDC_CMD_INPT16, Box_P_Value_1);
	DDX_Text(pDX, IDC_AVG_0, AVG_BOX[0]);
	DDX_Text(pDX, IDC_AVG_1, AVG_BOX[1]);
	DDX_Text(pDX, IDC_AVG_2, AVG_BOX[2]);
	DDX_Text(pDX, IDC_AVG_3, AVG_BOX[3]);
	DDX_Text(pDX, IDC_AVG_4, AVG_BOX[4]);
	DDX_Text(pDX, IDC_AVG_5, AVG_BOX[5]);
	DDX_Text(pDX, IDC_AVG_6, AVG_BOX[6]);
	DDX_Text(pDX, IDC_AVG_7, AVG_BOX[7]);
	DDX_Text(pDX, IDC_AVG_8, AVG_BOX[8]);
	DDX_Text(pDX, IDC_AVG_9, AVG_BOX[9]);
	DDX_Text(pDX, IDC_AVG_A, AVG_BOX[10]);
	DDX_Text(pDX, IDC_AVG_B, AVG_BOX[11]);
	DDX_Text(pDX, IDC_AVG_C, AVG_BOX[12]);
	DDX_Text(pDX, IDC_AVG_D, AVG_BOX[13]);
	DDX_Text(pDX, IDC_AVG_E, AVG_BOX[14]);
	DDX_Text(pDX, IDC_AVG_F, AVG_BOX[15]);
}

BEGIN_MESSAGE_MAP(CNRL66ClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDConnect, OnBnClickedConnect)
	ON_BN_CLICKED(IDDisconnect, OnBnClickedDisconnect)
	ON_BN_CLICKED(IDRESET, OnBnClickedReset)
	ON_BN_CLICKED(IDEXIT, OnBnClickedExit)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_COMPORT, OnEnChangeComport)
	ON_BN_CLICKED(IDCLEAR, OnBnClickedClear)
	ON_BN_CLICKED(IDSENDCOMMAND, OnBnClickedSendCommand)
	ON_EN_CHANGE(IDC_CMD_INPT2, OnEnChangeCmdInpt2)
	ON_EN_CHANGE(IDC_CMD_INPT1, OnEnChangeCmdInpt1)
	ON_EN_CHANGE(IDC_CMD_INPT3, OnEnChangeCmdInpt3)
	ON_EN_CHANGE(IDC_CMD_INPT4, OnEnChangeCmdInpt4)
	ON_EN_CHANGE(IDC_CMD_INPT5, OnEnChangeCmdInpt5)
	ON_BN_CLICKED(IDSENDHELLO, OnBnClickedSendhello)
	ON_BN_CLICKED(IDSENDTRIGGER, OnBnClickedSendtrigger)
	ON_BN_CLICKED(IDSENDSETUP, OnBnClickedSendsetup)
	ON_BN_CLICKED(IDSENDGETREADING, OnBnClickedSendgetreading)
	ON_BN_CLICKED(IDSENDSINGLE, OnBnClickedSendsingle)
	ON_BN_CLICKED(IDSENDCONTINOUS, OnBnClickedSendcontinous)
	ON_BN_CLICKED(IDSENDNRCONV, OnBnClickedSendnrconv)
	ON_BN_CLICKED(IDSENDRATE, OnBnClickedSendrate)
	ON_EN_CHANGE(IDC_CMD_INPT6, OnEnChangeCmdInpt6)
	ON_EN_CHANGE(IDC_CMD_INPT7, OnEnChangeCmdInpt7)
	ON_EN_CHANGE(IDC_CMD_INPT8, OnEnChangeCmdInpt8)
	ON_EN_CHANGE(IDC_CMD_INPT9, OnEnChangeCmdInpt9)
	ON_EN_CHANGE(IDC_CMD_INPT10, OnEnChangeCmdInpt10)
	ON_EN_CHANGE(IDC_CMD_INPT11, OnEnChangeCmdInpt11)
	ON_EN_CHANGE(IDC_CMD_INPT12, OnEnChangeCmdInpt12)
	ON_EN_CHANGE(IDC_CMD_INPT13, OnEnChangeCmdInpt13)
	ON_BN_CLICKED(IDSENDPERIODIC, OnBnClickedSendperiodic)
	ON_EN_CHANGE(IDC_CMD_INPT16, OnEnChangeCmdInpt16)
	ON_EN_CHANGE(IDC_CMD_INPT15, OnEnChangeCmdInpt15)
	ON_EN_CHANGE(IDC_AVG_0, OnEnChangeAvg1)
	ON_EN_CHANGE(IDC_AVG_1, OnEnChangeAvg2)
	ON_EN_CHANGE(IDC_AVG_2, OnEnChangeAvg3)
	ON_EN_CHANGE(IDC_AVG_3, OnEnChangeAvg4)
	ON_EN_CHANGE(IDC_AVG_4, OnEnChangeAvg5)
	ON_EN_CHANGE(IDC_AVG_5, OnEnChangeAvg6)
END_MESSAGE_MAP()


// CNRL66ClientDlg message handlers

BOOL CNRL66ClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	helocls = new class Helo_class();
	helocls->SetUp(FALSE,300,&scomm,this);
	HelloThread = AfxBeginThread(HelloFunctionThread, helocls);

	inbuffer = new class InBuffer();
	inbuffer->SetUp(this,&scomm);
	InBufferThread = AfxBeginThread(InBufferFunctionThread, inbuffer);

	SetTimer(MY_TIMER_REFRESH, 300, 0);	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNRL66ClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNRL66ClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNRL66ClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CNRL66ClientDlg::OnBnClickedConnect()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	scomm.Open(m_error,atoi(box_comport.GetBuffer()));
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedDisconnect()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	scomm.Close(m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}


void CNRL66ClientDlg::OnBnClickedExit()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	terminate=true;
	lock.Unlock();
	WaitForSingleObject(HelloThread,INFINITE);
	WaitForSingleObject(InBufferThread,INFINITE);
	OnCancel();
}


void CNRL66ClientDlg::OnBnClickedReset()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(TRUE);
	AVG_BOX[0]="-1";
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnTimer(UINT nIDEvent)
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	switch(nIDEvent)
	{
	case MY_TIMER_REFRESH:
		{
			if(clearscreen)
			{
				box_messages="";
				box_messages.Format("%d\r\n",nIDEvent);
				comment_box="";
				clearscreen=FALSE;
			}
			UpdateData(FALSE);
		}
		break;
	case MY_TIMER_FOLLOW:
		{
		}
		break;
	default:;
	}
	CDialog::OnTimer(nIDEvent);
	lock.Unlock();
}

void CNRL66ClientDlg::OnEnChangeComport()
{
	UpdateData(TRUE);	
}

void CNRL66ClientDlg::AddLogM(CString addthis)
{
	//lock mutex before using this function!
	CString fasz=box_messages;
	box_messages=addthis+fasz;
}

void CNRL66ClientDlg::AddLogC(CString addthis)
{
	//lock mutex before using this function!
	CString fasz=commresp;
	commresp=addthis+fasz;
}

void CNRL66ClientDlg::AddLogT(CString addthis)
{
	//lock mutex before using this function!
	CString fasz=comment_box;
	comment_box=addthis+fasz;
	
}

void CNRL66ClientDlg::OnBnClickedClear()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
    clearscreen=TRUE;
	lock.Unlock();
}



void CNRL66ClientDlg::OnBnClickedSendCommand()
{
	// TODO: Add your control notification handler code here
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	int ps;
	unsigned char tmp_lo,tmp_hi;
	aa=cmd_cmd_char[0];
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	ps = atoi(cmd_cmd_paramlength.GetBuffer());
	if(ps<4)
	{
		Convert2Code(atoi(cmd_cmd_param1.GetBuffer()),tmp_lo,tmp_hi);
		a_buffer[3]=tmp_lo;
		a_buffer[4]=tmp_hi;
		Convert2Code(atoi(cmd_cmd_param2.GetBuffer()),tmp_lo,tmp_hi);
		a_buffer[5]=tmp_lo;
		a_buffer[6]=tmp_hi;
		Convert2Code(atoi(cmd_cmd_param3.GetBuffer()),tmp_lo,tmp_hi);
		a_buffer[7]=tmp_lo;
		a_buffer[8]=tmp_hi;
		a_buffer[(ps+1)*2+1]=END_FRAME;	
		scomm.Write(a_buffer,(ps+2)*2,m_error);
	}

	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendhello()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('H',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	a_buffer[3]=END_FRAME;
	scomm.Write(a_buffer,4,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendtrigger()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('T',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	a_buffer[3]=END_FRAME;
	scomm.Write(a_buffer,4,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendsetup()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('S',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_S_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	a_buffer[5]=END_FRAME;
	scomm.Write(a_buffer,6,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendgetreading()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('A',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_A_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	a_buffer[5]=END_FRAME;
	scomm.Write(a_buffer,6,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendsingle()
{
		CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('1',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_1_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	a_buffer[5]=END_FRAME;
	scomm.Write(a_buffer,6,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendcontinous()
{
		CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('9',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_9_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	a_buffer[5]=END_FRAME;
	scomm.Write(a_buffer,6,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendnrconv()
{
		CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('N',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_N_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	aa=atoi(Box_N_Value_2.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[5]=tmp_lo;
	a_buffer[6]=tmp_hi;
	a_buffer[7]=END_FRAME;
	scomm.Write(a_buffer,8,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendrate()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('R',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_R_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	aa=atoi(Box_R_Value_2.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[5]=tmp_lo;
	a_buffer[6]=tmp_hi;
	a_buffer[7]=END_FRAME;
	scomm.Write(a_buffer,8,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnBnClickedSendperiodic()
{
	CSingleLock lock(&ui_mutex);
	lock.Lock();
	UpdateData(FALSE);
	CString m_error;
	CSingleLock slock(&scomm_mutex);
	slock.Lock();
	unsigned char a_buffer[10];
	unsigned char aa;
	unsigned char tmp_lo,tmp_hi;
	Convert2Code('P',tmp_lo,tmp_hi);
	a_buffer[0]=START_FRAME;	
	a_buffer[1]=tmp_lo;
	a_buffer[2]=tmp_hi;
	aa=atoi(Box_P_Value_1.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[3]=tmp_lo;
	a_buffer[4]=tmp_hi;
	aa=atoi(Box_P_Value_2.GetBuffer());
	Convert2Code(aa,tmp_lo,tmp_hi);
	a_buffer[5]=tmp_lo;
	a_buffer[6]=tmp_hi;
	a_buffer[7]=END_FRAME;
	scomm.Write(a_buffer,8,m_error);
	slock.Unlock();
	AddLogC(m_error);
	AddLogM(m_error);
	UpdateData(FALSE);
	lock.Unlock();
}

void CNRL66ClientDlg::OnEnChangeCmdInpt6()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt7()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt8()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt9()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt10()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt11()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt12()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt13()
{
	UpdateData(TRUE);
}



void CNRL66ClientDlg::OnEnChangeCmdInpt2()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt1()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt3()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt4()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt5()
{
	UpdateData(TRUE);
}
void CNRL66ClientDlg::OnEnChangeCmdInpt14()
{
	UpdateData(TRUE);
}


void CNRL66ClientDlg::OnEnChangeCmdInpt16()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeCmdInpt15()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg1()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg2()
{
		UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg3()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg4()
{
	UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg5()
{
UpdateData(TRUE);
}

void CNRL66ClientDlg::OnEnChangeAvg6()
{
UpdateData(TRUE);
}
