// NRL66ClientDlg.h : header file
//

#pragma once

#include "s_comm.h"
#include "inbuffer.h"

class Helo_class;
class InBuffer;

// CNRL66ClientDlg dialog
class CNRL66ClientDlg : public CDialog
{
	// Construction
public:
	CNRL66ClientDlg(CWnd* pParent = NULL);	// standard constructor

	// Dialog Data
	enum { IDD = IDD_NRL66CLIENT_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


	// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CString box_comport;
	CString box_messages;
	class S_comm scomm;
	afx_msg void OnBnClickedConnect();
	afx_msg void OnBnClickedDisconnect();
	afx_msg void OnBnClickedExit();
	afx_msg void OnBnClickedReset();
	afx_msg void OnBnClickedClear();
	afx_msg void OnEnChangeComport();

	afx_msg void OnTimer(UINT nIDEvent);

	void AddLogM(CString addthis);
	void AddLogC(CString addthis);
	void AddLogT(CString addthis);

	class InBuffer * inbuffer;
	class Helo_class * helocls;
	CWinThread *HelloThread;
	CWinThread *InBufferThread;

	unsigned char clearscreen;
	unsigned char followmode;
	unsigned char terminate;
	CString commresp;

	CString disp_adc[16];
	CString AVG_BOX[16];
	CString comment_box;

	CString cmd_cmd_char;

	CString cmd_cmd_param1;
	CString cmd_cmd_param2;
	CString cmd_cmd_param3;
	CString cmd_cmd_paramlength;

	CString Box_S_Value_1;
	CString Box_A_Value_1;
	CString Box_1_Value_1;
	CString Box_9_Value_1;
	CString Box_N_Value_1;
	CString Box_N_Value_2;
	CString Box_R_Value_1;
	CString Box_R_Value_2;
	CString Box_9_Value_2;
	CString Box_P_Value_2;
	CString Box_P_Value_1;

	afx_msg void OnBnClickedSendCommand();
	afx_msg void OnBnClickedSendhello();
	afx_msg void OnBnClickedSendtrigger();
	afx_msg void OnBnClickedSendsetup();
	afx_msg void OnBnClickedSendgetreading();
	afx_msg void OnBnClickedSendsingle();
	afx_msg void OnBnClickedSendcontinous();
	afx_msg void OnBnClickedSendnrconv();
	afx_msg void OnBnClickedSendrate();
	afx_msg void OnBnClickedSendperiodic();

	afx_msg void OnEnChangeCmdInpt6();
	afx_msg void OnEnChangeCmdInpt7();
	afx_msg void OnEnChangeCmdInpt8();
	afx_msg void OnEnChangeCmdInpt9();
	afx_msg void OnEnChangeCmdInpt10();
	afx_msg void OnEnChangeCmdInpt11();
	afx_msg void OnEnChangeCmdInpt12();
	afx_msg void OnEnChangeCmdInpt13();
	afx_msg void OnEnChangeCmdInpt2();
	afx_msg void OnEnChangeCmdInpt1();
	afx_msg void OnEnChangeCmdInpt3();
	afx_msg void OnEnChangeCmdInpt4();
	afx_msg void OnEnChangeCmdInpt5();
	afx_msg void OnEnChangeCmdInpt14();
	afx_msg void OnEnChangeCmdInpt16();
	afx_msg void OnEnChangeCmdInpt15();
	afx_msg void OnEnChangeAvg1();
	afx_msg void OnEnChangeAvg2();
	afx_msg void OnEnChangeAvg3();
	afx_msg void OnEnChangeAvg4();
	afx_msg void OnEnChangeAvg5();
	afx_msg void OnEnChangeAvg6();

};
