#pragma once

class CNRL66ClientDlg;

#include <afxmt.h>
#include "stdafx.h"
#include "NRL66Client.h"
#include "NRL66ClientDlg.h"

#define COM_POLL_PERIOD 100  //in [ms]

UINT InBufferFunctionThread(LPVOID pParam);

class InBuffer
{
public:
	InBuffer();
	~InBuffer();
	inline void SetUp(CNRL66ClientDlg * tmywch, S_comm * tmy_scomm)
			{mywch=tmywch;my_scomm=tmy_scomm;};
	void Put(unsigned char * put_value, int how_much);
	int ParseForAndRemove(unsigned char pcommand,
		         unsigned char * retparam, int &retprmsize);
	CNRL66ClientDlg * mywch;
	S_comm * my_scomm;
	inline void KillBuffer() {	bufferptr=0;};

private:	
	unsigned char * buffer;
	int bufferptr;
	void Remove(int p_from, int p_to);
};
